#import "FlutterPaudioPlugin.h"
#import <AVFoundation/AVFoundation.h>

@interface FlutterPaudioPlugin ()
@property(nonatomic, strong) AVAudioPlayer *player;
@property(nonatomic, strong) AVAudioSession *session;
@end

@implementation FlutterPaudioPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"flutter_paudio"
            binaryMessenger:[registrar messenger]];
  FlutterPaudioPlugin* instance = [[FlutterPaudioPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
   
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"playAudio" isEqualToString:call.method]) {
    if (_session == nil) {
      _session = [AVAudioSession sharedInstance];       
      [_session setActive:YES error:nil];       
      [_session setCategory:AVAudioSessionCategoryPlayback error:nil]; 
    } 
     
    FlutterStandardTypedData *typedData = call.arguments[@"data"];
    double speed = [(NSString *) call.arguments[@"speed"] doubleValue];
    NSData *data =typedData.data;
    NSLog(@"%lu", data.length);
    NSLog(@"playAudio");
    double duration = [self playAudio: data speed: speed];
    result(@(duration));
  } else if ([@"stopAudio" isEqualToString:call.method]) {
    [self.player stop];
    result(@"success");
  } else {
    result(FlutterMethodNotImplemented);
  }
}

-(double)playAudio:(NSData *)data speed: (double)speed{   
  AVAudioPlayer *player = [[AVAudioPlayer alloc] initWithData:data error:nil];
  self.player = player;
  [player prepareToPlay];
  self.player.rate = speed;
  self.player.enableRate = true;
  [player play];
  
  
  double duration = player.duration;
  duration /= speed;
  // AVAudioFormat* format = player.format;
  // duration = duration*(25600/format.sampleRate);
  return duration;
}

-(void)stopAudio{
  [self.player stop];
}

@end
