import 'dart:async';
import 'dart:typed_data';

import 'package:flutter/services.dart';

class FlutterPaudio {
  static const MethodChannel _channel =
      const MethodChannel('flutter_paudio');

  /// play audio with bytes,
  /// custom play speed with [speed] param 
  ///
  static Future<double> play(Uint8List bytes, double speed) async {
    final double duration = await _channel.invokeMethod('playAudio', {
       "data": bytes,
       "speed": speed,
    });
    return duration;
  }
  
  /// stop audio play
  static Future stop() async {
    return _channel.invokeMethod('stopAudio');
  }
}
